<?php
include_once $_SERVER['DOCUMENT_ROOT'] . '/include/shared-manual.inc';
$TOC = array();
$TOC_DEPRECATED = array();
$PARENTS = array();
include_once dirname(__FILE__) ."/toc/langref.inc";
$setup = array (
  'home' => 
  array (
    0 => 'index.php',
    1 => 'PHP Manual',
  ),
  'head' => 
  array (
    0 => 'UTF-8',
    1 => 'pt_BR',
  ),
  'this' => 
  array (
    0 => 'language.fibers.php',
    1 => 'Fibers',
  ),
  'up' => 
  array (
    0 => 'langref.php',
    1 => 'Refer&ecirc;ncia da Linguagem',
  ),
  'prev' => 
  array (
    0 => 'language.exceptions.extending.php',
    1 => 'Estendendo exce&ccedil;&otilde;es',
  ),
  'next' => 
  array (
    0 => 'language.generators.php',
    1 => 'Geradores',
  ),
  'alternatives' => 
  array (
  ),
  'source' => 
  array (
    'lang' => 'pt_BR',
    'path' => 'language/fibers.xml',
  ),
  'history' => 
  array (
  ),
);
$setup["toc"] = $TOC;
$setup["toc_deprecated"] = $TOC_DEPRECATED;
$setup["parents"] = $PARENTS;
manual_setup($setup);

contributors($setup);

?>
<div id="language.fibers" class="chapter">
 <h1 class="title">Fibers</h1>


 <div class="simplesect" id="language.fibers.overview">
  <h3 class="title">Visão geral de Fibers</h3>
  <p class="verinfo">(PHP 8 &gt;= 8.1.0)</p>
  <p class="para">
   Fibers representam funções interrompíveis de pilha completa. Fibers podem ser suspensas de qualquer lugar na pilha de chamadas,
   pausando a execução dentro de Fiber até que Fiber seja retomada posteriormente.
  </p>
  <p class="para">
   Fibers pausam toda a pilha de execução, portanto, o chamador direto da função não precisa alterar a forma
   como invoca a função.
  </p>
  <p class="para">
   A execução pode ser interrompida em qualquer lugar na pilha de chamadas usando <span class="methodname"><a href="fiber.suspend.php" class="methodname">Fiber::suspend()</a></span>
   (ou seja, a chamada para <span class="methodname"><a href="fiber.suspend.php" class="methodname">Fiber::suspend()</a></span> pode estar em uma função profundamente aninhada ou nem
   mesmo existir).
  </p>
  <p class="para">
   Ao contrário dos <span class="classname"><a href="class.generator.php" class="classname">Generator</a></span>s, cada <span class="classname"><a href="class.fiber.php" class="classname">Fiber</a></span> tem sua própria pilha de chamadas,
   permitindo que sejam pausadas em chamadas de função profundamente aninhadas. Uma função que declara um ponto de interrupção
   (isto é, chamando <span class="methodname"><a href="fiber.suspend.php" class="methodname">Fiber::suspend()</a></span>) não precisa alterar seu tipo de retorno, ao contrário de uma função
   que usa <a href="language.generators.syntax.php#control-structures.yield" class="link"><code class="literal">yield</code></a>, que deve retornar uma instância de <span class="classname"><a href="class.generator.php" class="classname">Generator</a></span>.
  </p>
  <p class="para">
   Fibers podem ser suspensas em qualquer chamada de função, incluindo aquelas chamadas de dentro da VM PHP, como funções
   fornecidas para <span class="function"><a href="function.array-map.php" class="function">array_map()</a></span> ou métodos chamados por <a href="control-structures.foreach.php" class="link"><code class="literal">foreach</code></a> em um
   objeto <span class="classname"><a href="class.iterator.php" class="classname">Iterator</a></span>.
  </p>
  <p class="para">
   Uma vez suspensa, a execução de Fiber pode ser retomada com qualquer valor usando <span class="methodname"><a href="fiber.resume.php" class="methodname">Fiber::resume()</a></span>
   ou lançando uma exceção na Fiber usando <span class="methodname"><a href="fiber.throw.php" class="methodname">Fiber::throw()</a></span>. O valor é retornado
   (ou exceção lançada) de <span class="methodname"><a href="fiber.suspend.php" class="methodname">Fiber::suspend()</a></span>.
  </p>
  <blockquote class="note"><p><strong class="note">Nota</strong>: 
   <span class="simpara">
    Antes do PHP 8.4.0, trocas de Fibers durante a execução de um
    <a href="language.oop5.decon.php#language.oop5.decon.destructor" class="link">destrutor</a> de objeto não eram
    permitidas.
   </span>
  </p></blockquote>

  <div class="example" id="language.fiber.example.basic">
   <p><strong>Exemplo #1 Uso básico</strong></p>
   <div class="example-contents">
<div class="phpcode"><code><span style="color: #000000"><span style="color: #0000BB">&lt;?php<br />$fiber </span><span style="color: #007700">= new </span><span style="color: #0000BB">Fiber</span><span style="color: #007700">(function (): </span><span style="color: #0000BB">void </span><span style="color: #007700">{<br />   </span><span style="color: #0000BB">$value </span><span style="color: #007700">= </span><span style="color: #0000BB">Fiber</span><span style="color: #007700">::</span><span style="color: #0000BB">suspend</span><span style="color: #007700">(</span><span style="color: #DD0000">'fiber'</span><span style="color: #007700">);<br />   echo </span><span style="color: #DD0000">"Value used to resume fiber: "</span><span style="color: #007700">, </span><span style="color: #0000BB">$value</span><span style="color: #007700">, </span><span style="color: #0000BB">PHP_EOL</span><span style="color: #007700">;<br />});<br /><br /></span><span style="color: #0000BB">$value </span><span style="color: #007700">= </span><span style="color: #0000BB">$fiber</span><span style="color: #007700">-&gt;</span><span style="color: #0000BB">start</span><span style="color: #007700">();<br /><br />echo </span><span style="color: #DD0000">"Value from fiber suspending: "</span><span style="color: #007700">, </span><span style="color: #0000BB">$value</span><span style="color: #007700">, </span><span style="color: #0000BB">PHP_EOL</span><span style="color: #007700">;<br /><br /></span><span style="color: #0000BB">$fiber</span><span style="color: #007700">-&gt;</span><span style="color: #0000BB">resume</span><span style="color: #007700">(</span><span style="color: #DD0000">'test'</span><span style="color: #007700">);<br /></span><span style="color: #0000BB">?&gt;</span></span></code></div>
   </div>

   <div class="example-contents"><p>O exemplo acima produzirá:</p></div>
   <div class="example-contents screen">
<div class="cdata"><pre>
Value from fiber suspending: fiber
Value used to resume fiber: test
</pre></div>
   </div>
  </div>

 </div>

</div>
<?php manual_footer($setup); ?>